' Manchester codec for BASCOM-AVR ver.2.0.7.5
' Made by audin 2014/06
' Refered to  
' http://www.sfcompiler.co.uk/wiki/pmwiki.php?n=SwordfishUser.Comparison
' http://www.sfcompiler.co.uk/wiki/pmwiki.php?n=SwordfishUser.ManchesterCode
'
' For ATMega328p

$regfile = "m328pdef.dat"
$crystal = 16000000
Config Portb = Output

' Global defs
Dim Index As Byte

Declare Sub Led_blink(byval State As Byte )
Declare Function Encode(byval Pvalue As Byte) As Word
Declare Function Decode(byval Pencodedvalue As Word , Byref Pdecodedvalue As Byte) As Byte

Sub Led_blink(byval State As Byte )
   Do
       If State = 1 Then
             Portb.5 = 1
             Waitms 500
             Portb.5 = 0
             Waitms 500
       Else
            Portb.5 = 1
       End If
   Loop
End Sub

'Encode...
Function Encode(byval Pvalue As Byte) As Word
   Encode = 0
   For Index = 0 To 7
      If Pvalue.0 = 0 Then
         Encode.14 = 1
      Else
         Encode.15 = 1
      End If
      If Index < 7 Then
            Shift Encode , Right , 2
      End If
      Shift Pvalue , Right , 1
   Next
End Function


' Decode...
Function Decode(byval Pencodedvalue As Word , Byref Pdecodedvalue As Byte) As Byte
   Decode = 1
   For Index = 0 To 7
      If Pencodedvalue.1 = 0 And Pencodedvalue.0 = 1 Then
         Pdecodedvalue.7 = 0
      Elseif Pencodedvalue.1 = 1 And Pencodedvalue.0 = 0 Then
             Pdecodedvalue.7 = 1
      Else
             Decode = 0
             Exit For
      End If
      Shift Pencodedvalue , Right , 2
      If Index < 7 Then
         Shift Pdecodedvalue , Right , 1
      End If
    Next
End Function

Dim Orgval As Byte
Dim Wencval As Word
Dim Bdecval As Byte
Dim Res As Byte

' main routine
Do
   For Orgval = 0 To 255
      Wencval = Encode(orgval )
      Res = Decode(wencval , Bdecval )
      If Orgval <> Bdecval Then
         Call Led_blink(1)
      End If
   Next
   Call Led_blink(0)
Loop

End
