@echo off
echo *** flashAVR.bat ***
echo.
REM  This batchfile is called from G@Stool.exe if an AVR-chipmodel is detected and
REM  no "FlashThis.bat" is present in the sourcefile-folder.
REM  You can adapt this file to your needs.
REM  %1 is replaced with the hexfile in double quotes i.e. "C:\My Folder\nice file.hex"
REM  %2 is replaced with the chipmodel i.e. tiny44
REM  G@Stool.exe makes the GCB@Syn root-folder the current folder.


REM  --- Your code here: ---------------------------------------

REM  Call AVRdude for UABASP programmer:
 "AVRdude\avrdude.exe" -c arduino -P COM7 -b 115200 -p AT%2 -U flash:w:%1:i

REM  Call AVRdude for STK500v2 programmer:
 rem "AVRdude\avrdude.exe" -c STK500v2 -P com4 -p AT%2 -U flash:w:%1:i

REM  Call AVRdude for DASA3 programmer:
 rem "AVRdude\avrdude.exe" -i 1 -c DASA3 -P com1 -p AT%2 -U flash:w:%1:i

REM  --- End of your code. ------------------------------------


REM  Creating "G@Stools\FlashError.txt" makes G@Stool to leave the message-window open:
if not errorlevel 1 goto END
 echo ERROR running: %0  with parameters  %1 %2 %3 %4 %5 %6 %7 %8 %9 >G@Stools\FlashError.txt
 echo ERROR running: %0  with parameters  %1 %2 %3 %4 %5 %6 %7 %8 %9
:END
